package com.tsl3060.open.extend.core.router.notify;

import com.alibaba.fastjson2.JSON;
import com.tsl3060.open.extend.core.INotifyListener;
import com.tsl3060.open.extend.core.NotifyRequest;
import com.tsl3060.open.extend.core.notify.CarbonIntegralNotify;
import com.tsl3060.open.extend.core.notify.IAnswer;
import com.tsl3060.open.extend.core.router.INotifyRouter;

public class CarbonIntegralNotifyRouter implements INotifyRouter {
    private final INotifyListener notifyListener;

    public CarbonIntegralNotifyRouter(INotifyListener notifyListener) {
        this.notifyListener = notifyListener;
    }

    @Override
    public String path() {
        return "/v1/wanshun/notify/integral";
    }

    @Override
    public IAnswer makeBody(NotifyRequest notifyRequest) throws Exception {

        CarbonIntegralNotify carbonIntegralNotify = JSON.to(CarbonIntegralNotify.class, notifyRequest.getPayload());

        return this.notifyListener.integral(carbonIntegralNotify);
    }
}
